#ifndef _LIB_SMB_PROTO_H_
#define _LIB_SMB_PROTO_H_
/* This file is automatically generated with "make proto". DO NOT EDIT */


/*The following definitions come from  libsmb/cliconnect.c  */

BOOL cli_session_setup_x(struct cli_state *cli,
				char *user,
				char *pass, int passlen,
				char *ntpass, int ntpasslen,
				char *user_domain);
BOOL cli_session_setup(struct cli_state *cli,
				char *user,
				char *pass, int passlen,
				char *ntpass, int ntpasslen,
				char *user_domain);
BOOL cli_ulogoff(struct cli_state *cli);
BOOL cli_send_tconX(struct cli_state *cli,
		    const char *share, const char *dev, const char *pass, int passlen);
BOOL cli_tdis(struct cli_state *cli);
void cli_negprot_send(struct cli_state *cli);
BOOL cli_negprot(struct cli_state *cli);
BOOL cli_session_request(struct cli_state *cli,
			 struct nmb_name *calling, struct nmb_name *called);
BOOL cli_connect(struct cli_state *cli, const char *host, int name_type, struct in_addr *ip);
BOOL cli_reestablish_connection(struct cli_state *cli);
BOOL cli_establish_connection(struct cli_state *cli,
				const char *dest_host, struct in_addr *dest_ip,
				struct nmb_name *calling, struct nmb_name *called,
				char *service, char *service_type,
				BOOL do_shutdown, BOOL do_tcon);

/*The following definitions come from  libsmb/clidomain.c  */

BOOL get_dc_name(const char *domain, char *server, int type);
char *get_trusted_serverlist(const char *domain);
BOOL get_any_dc_name(const char *domain, char *srv_name);

/*The following definitions come from  libsmb/clientgen.c  */

int cli_set_port(struct cli_state *cli, int port);
BOOL cli_receive_smb(struct cli_state *cli);
BOOL cli_send_smb(struct cli_state *cli);
void cli_setup_packet(struct cli_state *cli);
void cli_setup_bcc(struct cli_state *cli, void *p);
void cli_init_creds(struct cli_state *cli, const struct ntuser_creds *usr);
struct cli_state *cli_initialise(struct cli_state *cli);
void cli_close_socket(struct cli_state *cli);
void cli_shutdown(struct cli_state *cli);
void cli_sockopt(struct cli_state *cli, char *options);
uint16 cli_setpid(struct cli_state *cli, uint16 pid);

/*The following definitions come from  libsmb/clierror.c  */

char *cli_errstr(struct cli_state *cli);
NTSTATUS cli_nt_error(struct cli_state *cli);
int cli_dos_error(struct cli_state *cli, uint8 *eclass, uint32 *ecode);
int cli_errno(struct cli_state *cli);
BOOL cli_is_error(struct cli_state *cli);
BOOL cli_is_dos_error(struct cli_state *cli);
void cli_safe_errstr(struct cli_state *cli, char *err_msg, size_t msglen);
int cli_error(struct cli_state *cli, uint8 *eclass, uint32 *ecode);

/*The following definitions come from  libsmb/clifile.c  */

BOOL cli_rename(struct cli_state *cli, const char *fname_src, const char *fname_dst);
BOOL cli_unlink(struct cli_state *cli, const char *fname);
BOOL cli_mkdir(struct cli_state *cli, const char *dname);
BOOL cli_rmdir(struct cli_state *cli, const char *dname);
int cli_nt_create(struct cli_state *cli, const char *fname);
int cli_open(struct cli_state *cli, const char *fname, int flags, int share_mode);
BOOL cli_close(struct cli_state *cli, int fnum);
BOOL cli_lock(struct cli_state *cli, int fnum,
	      uint32 offset, uint32 len, int timeout, enum brl_type lock_type);
BOOL cli_unlock(struct cli_state *cli, int fnum, uint32 offset, uint32 len);
BOOL cli_getattrE(struct cli_state *cli, int fd,
		  uint16 *attr, size_t *size,
		  time_t *c_time, time_t *a_time, time_t *m_time);
BOOL cli_getatr(struct cli_state *cli, const char *fname,
		uint16 *attr, size_t *size, time_t *t);
BOOL cli_setatr(struct cli_state *cli, const char *fname, uint16 attr, time_t t);
BOOL cli_chkpath(struct cli_state *cli, const char *path);
BOOL cli_dskattr(struct cli_state *cli, int *bsize, int *total, int *avail);

/*The following definitions come from  libsmb/clilist.c  */

int cli_list(struct cli_state *cli,const char *Mask,uint16 attribute,
	     void (*fn)(file_info *, const char *, void *), void *state);

/*The following definitions come from  libsmb/climessage.c  */

BOOL cli_message_start(struct cli_state *cli, char *host, char *username,
			      int *grp);
BOOL cli_message_text(struct cli_state *cli, char *msg, int len, int grp);
BOOL cli_message_end(struct cli_state *cli, int grp);

/*The following definitions come from  libsmb/clioplock.c  */

BOOL cli_oplock_ack(struct cli_state *cli, int fnum, unsigned char level);

/*The following definitions come from  libsmb/cliprint.c  */

int cli_print_queue(struct cli_state *cli,
		    void (*fn)(struct print_job_info *));
int cli_printjob_del(struct cli_state *cli, int job);

/*The following definitions come from  libsmb/clirap.c  */

BOOL cli_api_pipe(struct cli_state *cli, char *pipe_name,
                  uint16 *setup, uint32 setup_count, uint32 max_setup_count,
                  char *params, uint32 param_count, uint32 max_param_count,
                  char *data, uint32 data_count, uint32 max_data_count,
                  char **rparam, uint32 *rparam_count,
                  char **rdata, uint32 *rdata_count);
BOOL cli_api(struct cli_state *cli,
	     char *param, int prcnt, int mprcnt,
	     char *data, int drcnt, int mdrcnt,
	     char **rparam, size_t *rprcnt,
	     char **rdata, size_t *rdrcnt);
BOOL cli_NetWkstaUserLogon(struct cli_state *cli,
			   const char *user, const char *workstation,
			   uint32 *privileges, fstring eff_name);
int cli_RNetShareEnum(struct cli_state *cli, void (*fn)(const char *, uint32, const char *));
BOOL cli_NetServerEnum(struct cli_state *cli, char *workgroup, uint32 stype,
		       void (*fn)(const char *, uint32, const char *));
BOOL cli_oem_change_password(struct cli_state *cli, const char *user, const char *new_password,
                             const char *old_password);
BOOL cli_qpathinfo(struct cli_state *cli, const char *fname,
		   time_t *c_time, time_t *a_time, time_t *m_time,
		   size_t *size, uint16 *mode);
BOOL cli_qpathinfo2(struct cli_state *cli, const char *fname,
		    time_t *c_time, time_t *a_time, time_t *m_time,
		    time_t *w_time, size_t *size, uint16 *mode,
		    SMB_INO_T *ino);
BOOL cli_qfileinfo(struct cli_state *cli, int fnum,
		   uint16 *mode, size_t *size,
		   time_t *c_time, time_t *a_time, time_t *m_time,
		   time_t *w_time, SMB_INO_T *ino);
NTSTATUS cli_qpathinfo_alt_name(struct cli_state *cli, const char *fname, fstring alt_name);

/*The following definitions come from  libsmb/clireadwrite.c  */

size_t cli_read_one(struct cli_state *cli, int fnum, char *buf, off_t offset, size_t size);
size_t cli_read(struct cli_state *cli, int fnum, char *buf, off_t offset, size_t size, BOOL overlap);
ssize_t cli_write(struct cli_state *cli,
		  int fnum, uint16 write_mode,
		  char *buf, off_t offset, size_t size, size_t bytes_left);

/*The following definitions come from  libsmb/clistr.c  */

int clistr_push(struct cli_state *cli, void *dest, const char *src, int dest_len, int flags);
int clistr_pull(struct cli_state *cli, char *dest, const void *src, int dest_len, int src_len,
		int flags);
int clistr_align_out(struct cli_state *cli, const void *p, int flags);
int clistr_align_in(struct cli_state *cli, const void *p, int flags);

/*The following definitions come from  libsmb/clitrans.c  */

BOOL cli_send_trans(struct cli_state *cli, int trans,
		    const char *pipe_name,
                           int fid, int flags,
                           uint16 *setup, size_t lsetup, size_t msetup,
                           char *param, size_t lparam, size_t mparam,
                           char *data, size_t ldata, size_t mdata);
BOOL cli_receive_trans(struct cli_state *cli,int trans,
                              char **param, size_t *param_len,
                              char **data, size_t *data_len);

/*The following definitions come from  libsmb/credentials.c  */

char *credstr(const uchar *cred);
void cred_session_key(DOM_CHAL *clnt_chal, DOM_CHAL *srv_chal, const char *pass,
		      uchar session_key[8]);
void cred_create(uchar session_key[8], DOM_CHAL *stor_cred, UTIME timestamp,
		 DOM_CHAL *cred);
int cred_assert(const DOM_CHAL *cred, uchar session_key[8],
		DOM_CHAL *stored_cred, UTIME timestamp);
BOOL clnt_deal_with_creds(uchar sess_key[8],
			  DOM_CRED *sto_clnt_cred, DOM_CRED *rcv_srv_cred);
BOOL deal_with_creds(uchar sess_key[8],
		     DOM_CRED *sto_clnt_cred,
		     const DOM_CRED *rcv_clnt_cred, DOM_CRED *rtn_srv_cred);
void copy_nt_creds(struct ntuser_creds *to,
				const struct ntuser_creds *from);

/*The following definitions come from  libsmb/errormap.c  */

NTSTATUS dos_to_ntstatus(int eclass, int ecode);
void ntstatus_to_dos(NTSTATUS ntstatus, uint8 *eclass, uint32 *ecode);
NTSTATUS werror_to_ntstatus(WERROR error);
WERROR ntstatus_to_werror(NTSTATUS error);
NTSTATUS map_nt_error_from_unix(int unix_error);

/*The following definitions come from  libsmb/pwd_cache.c  */

void pwd_init(struct pwd_info *pwd);
BOOL pwd_is_nullpwd(const struct pwd_info *pwd);
BOOL pwd_compare(const struct pwd_info *pwd1, const struct pwd_info *pwd2);
void pwd_read(struct pwd_info *pwd, char *passwd_report, BOOL do_encrypt);
void pwd_set_nullpwd(struct pwd_info *pwd);
void pwd_set_cleartext(struct pwd_info *pwd, char *clr);
void pwd_get_cleartext(struct pwd_info *pwd, char *clr);
void pwd_set_lm_nt_16(struct pwd_info *pwd,
		      const uchar lm_pwd[16], const uchar nt_pwd[16]);
void pwd_get_lm_nt_16(const struct pwd_info *pwd, uchar lm_pwd[16],
		      uchar nt_pwd[16]);
void pwd_make_lm_nt_16(struct pwd_info *pwd, char *clr);
void pwd_make_lm_nt_owf2(struct pwd_info *pwd, const uchar srv_key[8],
			 const char *user, const char *server,
			 const char *domain, uchar sess_key[16]);
void pwd_make_lm_nt_owf(struct pwd_info *pwd, uchar cryptkey[8],
			uchar sess_key[16]);
void pwd_get_lm_nt_owf(struct pwd_info *pwd, uchar lm_owf[24],
		       uchar * nt_owf, size_t * nt_owf_len);

/*The following definitions come from  libsmb/smbdes.c  */

void smbhash(uchar *out, const uchar *in, const uchar *key, int forw);
void E_P16(uchar *p14,uchar *p16);
void E_P24(const uchar *p21, const uchar *c8, uchar *p24);
void D_P16(const uchar *p14, const uchar *in, uchar *out);
void E_old_pw_hash( const uchar *p14, const uchar *in, uchar *out);
void cred_hash1(uchar *out, const uchar *in, const uchar *key);
void cred_hash2(uchar *out,uchar *in,uchar *key);
void cred_hash3(uchar *out, const uchar *in,uchar *key, int forw);
void SamOEMhash( uchar *data, const uchar *key, int val);
void sam_pwd_hash(unsigned int rid, const uchar *in, uchar *out, int forw);

/*The following definitions come from  libsmb/smbencrypt.c  */

void SMBencrypt(const uchar * pwrd, uchar * c8, uchar * p24);
void nt_lm_owf_gen(const char *pwd, uchar nt_p16[16], uchar lm_p16[16]);
void ntv2_owf_gen(const uchar owf[16],
		  const char *user_in, const char *domain_in, uchar kr_buf[16]);
void SMBOWFencrypt(const uchar passwd[16], const uchar * c8, uchar p24[24]);
void NTLMSSPOWFencrypt(const uchar pwrd[8], const uchar * ntlmchalresp,
		       uchar p24[24]);
BOOL make_oem_passwd_hash(uchar data[516],
			  const char *pwrd, int new_pw_len,
			  const uchar old_pw_hash[16], BOOL unicode);
void SMBOWFencrypt_ntv2(const uchar kr[16],
			const uchar * srv_chal, int srv_chal_len,
			const uchar * cli_chal, int cli_chal_len,
			uchar resp_buf[16]);
void SMBsesskeygen_ntv2(const uchar kr[16],
			const uchar * nt_resp, uchar sess_key[16]);
void SMBsesskeygen_ntv1(const uchar kr[16],
			const uchar * nt_resp, uchar sess_key[16]);
void ntlmv2_generate_client_chal(uchar *lm_cli_chal,
		       uchar *nt_cli_chal, size_t *nt_cli_chal_len,
		       const char *srv, const char *dom);
void nt_owf_genW(const UNISTR2 *pwd, uchar nt_p16[16]);
void nt_lm_owf_genW(const UNISTR2 *pwd, uchar nt_p16[16], uchar lm_p16[16]);
BOOL nt_encrypt_string2(STRING2 * out, const STRING2 * in, const uchar * key);
BOOL nt_decrypt_string2(STRING2 * out, const STRING2 * in, const uchar * key);
BOOL decode_pw_buffer(const char buffer[516], char *new_pwrd,
		      int new_pwrd_size, uint32 *new_pw_len);
BOOL encode_pw_buffer(char buffer[516], const char *new_pass,
		      int new_pw_len, BOOL nt_pass_set);

/*The following definitions come from  libsmb/smberr.c  */

BOOL smb_safe_errstr(char *inbuf, char *msg, size_t len);
char *smb_errstr(char *inbuf);

/*The following definitions come from  libsmb/util_smb_packet.c  */

void show_msg(char *buf);
int set_message_bcc(char *buf,int num_bytes);
int set_message_end(void *outbuf,void *end_ptr);
BOOL send_smb(Socket fd, char *buffer);
ssize_t read_smb_length(Socket fd, char *inbuf, unsigned int timeout);
BOOL receive_smb(Socket fd, char *buffer, unsigned int timeout);
void make_dir_struct(char *buf, const char *mask, const char *fname,
		     SMB_OFF_T size, int mode, time_t date, BOOL case_sensitive);
BOOL send_keepalive(Socket client);
BOOL cifs_ptr_in_smbbuf(void *inbuf, const void *src);
void cifs_put_dos_date(void *dest, const NTTIME *nt);
void cifs_put_dos_date2(void *dest, const NTTIME *nt);
void cifs_put_dos_date3(void *dest, const NTTIME *nt);
void cifs_put_nttime(void *dest, const NTTIME *nt);
size_t cifs_align_string(const void *packet, const void *base_ptr, const char *p, int flags);
#endif /* _LIB_SMB_PROTO_H_ */
