/* 
   Unix SMB/Netbios implementation.
   Version 1.9.
   SMB parameters and setup
   Copyright (C) Luke Kenneth Casson Leighton 1996-2001
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef _RPC_CREDS_H /* _RPC_CREDS_H */
#define _RPC_CREDS_H 

typedef struct ntuser_struct
{
	UNIHDR hdr_ntuser_name;    /* username unicode string header */
	UNIHDR hdr_domain_name;    /* domainname unicode string header */
	uint8 user_sess_key[16]; /* user session key */

	UNISTR2 uni_ntuser_name;    /* username unicode string */
	UNISTR2 uni_domain_name; /* domain unicode string */

} ntuser_struct;

typedef struct cred_command
{
	uint16 version;
	uint16 command;

	fstring pipename;
	fstring hostname; /* client connecting hostname */

	/* only sent if version == 0x0.  should really be in a union. */
	uint32 ptr_vuser;
	vuser_struct *vuser;

	/* only sent if version == 0x1.  should really be in a union.*/
	uint32 ptr_ntuser;

} CREDS_CMD;
	
#endif /* _RPC_CREDS_H */

