/*
   Readline wrapper,
   makes rest nicer to look at.
   Copyright (C) Elrond <elrond@samba-tng.org> 2004

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
/* MKPROTO: NONE			(do not remove this line) */


#include "includes.h"
#include "tng_readline.h"



char *tng_micro_readline(const char *prompt)
{
#ifdef HAVE_READLINE
	char *temp = readline(prompt);

	if (! temp)
		return temp;
	if (*temp)
		add_history(temp);

	return temp;
#else
	char inputbuffer[2048];
	printf("%s", prompt);
	fflush(stdout);

	if (!fgets(inputbuffer, sizeof(inputbuffer)-10, stdin))
		return NULL;

	return strdup(inputbuffer);
#endif
}
